package replace;

public class Replace
{
  /*@
    @ requires a != null;
    @ assignable a[*];
    @ ensures (\forall int j; 0 <= j && j < a.length; 
    @           (\old(a[j]) == x ==> a[j] == y) &&
    @           (\old(a[j]) != x ==> a[j] == \old(a[j]))); 
    @*/
  public static void replace(int[] a, int x, int y)
  {
    int n = a.length;
    int i = 0;
    /*@ loop_invariant 
      @   a != null && n == a.length && 
      @   0 <= i && i <= n &&
      @   (\forall int j; 0 <= j && j < i; 
      @       (\old(a[j]) == x ==> a[j] == y) &&
      @       (\old(a[j]) != x ==> a[j] == \old(a[j]))) &&
      @   (\forall int j; i <= j && j < n; a[j] == \old(a[j]));
      @ assignable i, a[*];
      @ decreases n-i;
      @*/
    while (i < n)
    {
      if (a[i] == x) a[i] = y;
      i = i+1;
    }
  }
}
